// **********************************************************************
//
// Copyright (c) 2003-2007 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.2.1
// Generated from file `Locator.ice'

#ifndef __IceGrid_Locator_h__
#define __IceGrid_Locator_h__

#include <Ice/LocalObjectF.h>
#include <Ice/ProxyF.h>
#include <Ice/ObjectF.h>
#include <Ice/Exception.h>
#include <Ice/LocalObject.h>
#include <Ice/Proxy.h>
#include <Ice/Object.h>
#include <Ice/Outgoing.h>
#include <Ice/OutgoingAsync.h>
#include <Ice/Incoming.h>
#include <Ice/IncomingAsync.h>
#include <Ice/Direct.h>
#include <Ice/UserExceptionFactory.h>
#include <Ice/FactoryTable.h>
#include <Ice/StreamF.h>
#include <Ice/Locator.h>
#include <Ice/UndefSysMacros.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 302
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

#ifndef ICE_GRID_API
#   ifdef ICE_GRID_API_EXPORTS
#       define ICE_GRID_API ICE_DECLSPEC_EXPORT
#   else
#       define ICE_GRID_API ICE_DECLSPEC_IMPORT
#   endif
#endif

namespace IceProxy
{

namespace IceGrid
{

class Registry;
ICE_GRID_API bool operator==(const Registry&, const Registry&);
ICE_GRID_API bool operator!=(const Registry&, const Registry&);
ICE_GRID_API bool operator<(const Registry&, const Registry&);
ICE_GRID_API bool operator<=(const Registry&, const Registry&);
ICE_GRID_API bool operator>(const Registry&, const Registry&);
ICE_GRID_API bool operator>=(const Registry&, const Registry&);

class Query;
ICE_GRID_API bool operator==(const Query&, const Query&);
ICE_GRID_API bool operator!=(const Query&, const Query&);
ICE_GRID_API bool operator<(const Query&, const Query&);
ICE_GRID_API bool operator<=(const Query&, const Query&);
ICE_GRID_API bool operator>(const Query&, const Query&);
ICE_GRID_API bool operator>=(const Query&, const Query&);

class Locator;
ICE_GRID_API bool operator==(const Locator&, const Locator&);
ICE_GRID_API bool operator!=(const Locator&, const Locator&);
ICE_GRID_API bool operator<(const Locator&, const Locator&);
ICE_GRID_API bool operator<=(const Locator&, const Locator&);
ICE_GRID_API bool operator>(const Locator&, const Locator&);
ICE_GRID_API bool operator>=(const Locator&, const Locator&);

}

}

namespace IceGrid
{

class Registry;
ICE_GRID_API bool operator==(const Registry&, const Registry&);
ICE_GRID_API bool operator!=(const Registry&, const Registry&);
ICE_GRID_API bool operator<(const Registry&, const Registry&);
ICE_GRID_API bool operator<=(const Registry&, const Registry&);
ICE_GRID_API bool operator>(const Registry&, const Registry&);
ICE_GRID_API bool operator>=(const Registry&, const Registry&);

class Query;
ICE_GRID_API bool operator==(const Query&, const Query&);
ICE_GRID_API bool operator!=(const Query&, const Query&);
ICE_GRID_API bool operator<(const Query&, const Query&);
ICE_GRID_API bool operator<=(const Query&, const Query&);
ICE_GRID_API bool operator>(const Query&, const Query&);
ICE_GRID_API bool operator>=(const Query&, const Query&);

class Locator;
ICE_GRID_API bool operator==(const Locator&, const Locator&);
ICE_GRID_API bool operator!=(const Locator&, const Locator&);
ICE_GRID_API bool operator<(const Locator&, const Locator&);
ICE_GRID_API bool operator<=(const Locator&, const Locator&);
ICE_GRID_API bool operator>(const Locator&, const Locator&);
ICE_GRID_API bool operator>=(const Locator&, const Locator&);

}

namespace IceInternal
{

ICE_GRID_API void incRef(::IceGrid::Registry*);
ICE_GRID_API void decRef(::IceGrid::Registry*);

ICE_GRID_API void incRef(::IceProxy::IceGrid::Registry*);
ICE_GRID_API void decRef(::IceProxy::IceGrid::Registry*);

ICE_GRID_API void incRef(::IceGrid::Query*);
ICE_GRID_API void decRef(::IceGrid::Query*);

ICE_GRID_API void incRef(::IceProxy::IceGrid::Query*);
ICE_GRID_API void decRef(::IceProxy::IceGrid::Query*);

ICE_GRID_API void incRef(::IceGrid::Locator*);
ICE_GRID_API void decRef(::IceGrid::Locator*);

ICE_GRID_API void incRef(::IceProxy::IceGrid::Locator*);
ICE_GRID_API void decRef(::IceProxy::IceGrid::Locator*);

}

namespace IceGrid
{

typedef ::IceInternal::Handle< ::IceGrid::Registry> RegistryPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IceGrid::Registry> RegistryPrx;

ICE_GRID_API void __write(::IceInternal::BasicStream*, const RegistryPrx&);
ICE_GRID_API void __read(::IceInternal::BasicStream*, RegistryPrx&);
ICE_GRID_API void __write(::IceInternal::BasicStream*, const RegistryPtr&);
ICE_GRID_API void __patch__RegistryPtr(void*, ::Ice::ObjectPtr&);

ICE_GRID_API void __addObject(const RegistryPtr&, ::IceInternal::GCCountMap&);
ICE_GRID_API bool __usesClasses(const RegistryPtr&);
ICE_GRID_API void __decRefUnsafe(const RegistryPtr&);
ICE_GRID_API void __clearHandleUnsafe(RegistryPtr&);

typedef ::IceInternal::Handle< ::IceGrid::Query> QueryPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IceGrid::Query> QueryPrx;

ICE_GRID_API void __write(::IceInternal::BasicStream*, const QueryPrx&);
ICE_GRID_API void __read(::IceInternal::BasicStream*, QueryPrx&);
ICE_GRID_API void __write(::IceInternal::BasicStream*, const QueryPtr&);
ICE_GRID_API void __patch__QueryPtr(void*, ::Ice::ObjectPtr&);

ICE_GRID_API void __addObject(const QueryPtr&, ::IceInternal::GCCountMap&);
ICE_GRID_API bool __usesClasses(const QueryPtr&);
ICE_GRID_API void __decRefUnsafe(const QueryPtr&);
ICE_GRID_API void __clearHandleUnsafe(QueryPtr&);

typedef ::IceInternal::Handle< ::IceGrid::Locator> LocatorPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IceGrid::Locator> LocatorPrx;

ICE_GRID_API void __write(::IceInternal::BasicStream*, const LocatorPrx&);
ICE_GRID_API void __read(::IceInternal::BasicStream*, LocatorPrx&);
ICE_GRID_API void __write(::IceInternal::BasicStream*, const LocatorPtr&);
ICE_GRID_API void __patch__LocatorPtr(void*, ::Ice::ObjectPtr&);

ICE_GRID_API void __addObject(const LocatorPtr&, ::IceInternal::GCCountMap&);
ICE_GRID_API bool __usesClasses(const LocatorPtr&);
ICE_GRID_API void __decRefUnsafe(const LocatorPtr&);
ICE_GRID_API void __clearHandleUnsafe(LocatorPtr&);

}

namespace IceGrid
{

}

namespace IceAsync
{

}

namespace IceProxy
{

namespace IceGrid
{

class ICE_GRID_API Locator : virtual public ::IceProxy::Ice::Locator
{
public:

    ::IceGrid::RegistryPrx getLocalRegistry()
    {
        return getLocalRegistry(0);
    }
    ::IceGrid::RegistryPrx getLocalRegistry(const ::Ice::Context& __ctx)
    {
        return getLocalRegistry(&__ctx);
    }
    
private:

    ::IceGrid::RegistryPrx getLocalRegistry(const ::Ice::Context*);
    
public:

    ::IceGrid::QueryPrx getLocalQuery()
    {
        return getLocalQuery(0);
    }
    ::IceGrid::QueryPrx getLocalQuery(const ::Ice::Context& __ctx)
    {
        return getLocalQuery(&__ctx);
    }
    
private:

    ::IceGrid::QueryPrx getLocalQuery(const ::Ice::Context*);
    
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

}

}

namespace IceDelegate
{

namespace IceGrid
{

class ICE_GRID_API Locator : virtual public ::IceDelegate::Ice::Locator
{
public:

    virtual ::IceGrid::RegistryPrx getLocalRegistry(const ::Ice::Context*) = 0;

    virtual ::IceGrid::QueryPrx getLocalQuery(const ::Ice::Context*) = 0;
};

}

}

namespace IceDelegateM
{

namespace IceGrid
{

class ICE_GRID_API Locator : virtual public ::IceDelegate::IceGrid::Locator,
                             virtual public ::IceDelegateM::Ice::Locator
{
public:

    virtual ::IceGrid::RegistryPrx getLocalRegistry(const ::Ice::Context*);

    virtual ::IceGrid::QueryPrx getLocalQuery(const ::Ice::Context*);
};

}

}

namespace IceDelegateD
{

namespace IceGrid
{

class ICE_GRID_API Locator : virtual public ::IceDelegate::IceGrid::Locator,
                             virtual public ::IceDelegateD::Ice::Locator
{
public:

    virtual ::IceGrid::RegistryPrx getLocalRegistry(const ::Ice::Context*);

    virtual ::IceGrid::QueryPrx getLocalQuery(const ::Ice::Context*);
};

}

}

namespace IceGrid
{

class ICE_GRID_API Locator : virtual public ::Ice::Locator
{
public:

    typedef LocatorPrx ProxyType;
    typedef LocatorPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual ::IceGrid::RegistryPrx getLocalRegistry(const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___getLocalRegistry(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::IceGrid::QueryPrx getLocalQuery(const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___getLocalQuery(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void ICE_GRID_API __patch__LocatorPtr(void*, ::Ice::ObjectPtr&);

}

#endif
